第八章 贪心算法 part04
今日任务: 860.柠檬水找零 ;406.根据身高重建队列 ; 452. 用最少数量的箭引爆气球
卡哥建议:
重点:
参考链接:代码随想录:代码随想录 (programmercarl.com)
补充:
860.柠檬水找零
题目讲解(全):代码随想录
题目建议:本题看上好像挺难,其实挺简单的,大家先尝试自己做一做。
刷题链接:力扣题目链接
class Solution {
public:
bool lemonadeChange(vector<int>& bills) {
int five = 0, ten = 0, twenty = 0;
for (int bill : bills) {
// 情况一
if (bill == 5) five++;
// 情况二
if (bill == 10) {
if (five <= 0) return false;
ten++;
five--;
}
// 情况三
if (bill == 20) {
// 优先消耗10美元,因为5美元的找零用处更大,能多留着就多留着
if (five > 0 && ten > 0) {
five--;
ten--;
twenty++; // 其实这行代码可以删了,因为记录20已经没有意义了,不会用20来找零
} else if (five >= 3) {
five -= 3;
twenty++; // 同理,这行代码也可以删了
} else return false;
}
}
return true;
}
};
全部考虑
class Solution {
public:
bool lemonadeChange(vector<int>& bills) {
int five = 0;
int ten = 0;
for (int i = 0; i < bills.size(); i++) {
if (bills[i] == 5) {
five++;
} else if (bills[i] == 10) {
five--;
ten++;
} else if (bills[i] == 20) {
if (ten > 0) {
ten--;
five--;
} else {
five -= 3;
}
}
if (five < 0 || ten < 0) return false;
}
return true;
}
};
视频讲解:贪心算法,看上去复杂,其实逻辑都是固定的!LeetCode:860.柠檬水找零
看到题目的第一思路:
看完代码随想录之后的想法:
自己实现过程中遇到哪些困难:
每日精华:
类似题目:
406.根据身高重建队列
题目讲解(全):代码随想录
题目建议:本题有点难度,和分发糖果类似,不要两头兼顾,处理好一边再处理另一边
刷题链接:力扣题目链接
class Solution {
public:
static bool cam(const vector<int>& a,const vector<int>& b){
if(a[0] == b[0]) return a[1] < b[1];
return a[0] > b[0];
}
vector<vector<int>> reconstructQueue(vector<vector<int>>& people) {
sort(people.begin(),people.end(),cam);
vector<vector<int>> peo;
for(int i=0;i<people.size();i++){
int position = people[i][1];
peo.insert(peo.begin()+position,people[i]);
}
return peo;
}
};
插入的话,还是链表合适
class Solution {
public:
static bool cmp(const vector<int>& a,const vector<int>& b){
if(a[0] == b[0]) return a[1] < b[1];
return a[0] > b[0];
}
vector<vector<int>> reconstructQueue(vector<vector<int>>& people) {
sort(people.begin(),people.end(),cmp);
list<vector<int>> que;
for(int i=0;i<people.size();i++){
int position = people[i][1];
std::list<vector<int>>::iterator it=que.begin();
while(position--){
it++;
}
que.insert(it,people[i]);
}
return vector<vector<int>> (que.begin(),que.end());
}
};
视频讲解:贪心算法,不要两边一起贪,会顾此失彼 | LeetCode:406.根据身高重建队列
看到题目的第一思路:
看完代码随想录之后的想法:
自己实现过程中遇到哪些困难:
每日精华:
类似题目:
452. 用最少数量的箭引爆气球
题目讲解(全):代码随想录
题目建议:本题是一道 重叠区间的题目,好好做一做,因为明天三道题目,都是 重叠区间。
刷题链接:力扣题目链接
class Solution {
public:
static bool cmp(const vector<int>& a,const vector<int>& b){
return a[0]<b[0];
}
int findMinArrowShots(vector<vector<int>>& points) {
if(points.size() == 0)return 0;
sort(points.begin(),points.end(),cmp);
int result=1;
for(int i=1;i<points.size();++i){
if(points[i][0] > points[i-1][1]){
result++;
}
else{
points[i][1]=min(points[i][1],points[i-1][1]);
}
}
return result;
}
};
视频讲解:贪心算法,判断重叠区间问题 | LeetCode:452.用最少数量的箭引爆气球
看到题目的第一思路:
看完代码随想录之后的想法:
自己实现过程中遇到哪些困难:
每日精华:
类似题目:
今日收获,记录一下自己的学习时长:
优质文章:学习参考: